<?php

namespace common\modules\sessions\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;

use common\modules\sessions\models\Session;
use common\modules\sessions\models\SessionUrl;

/**
 * SearchSession represents the model behind the search form about `common\modules\sessions\models\Session`.
 */
class SearchSession extends Session
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'user_id', 'created_at'], 'integer'],
            [['PHPSESSID', 'ip'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Session::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->select(['*', 'urls.time']);

        $queryUrl = SessionUrl::find()
            ->select('session_id, SUM('.SessionUrl::tableName().'.updated_at - '.SessionUrl::tableName().'.created_at) as time')
            ->groupBy('session_id');

        $query->leftJoin(['urls' => $queryUrl], 'urls.session_id = id');

        // grid filtering conditions
        $query->andFilterWhere([
            't.id' => $this->id,
            't.user_id' => $this->user_id,
            't.created_at' => $this->created_at
        ]);

        $query->andFilterWhere(['like', 't.PHPSESSID', $this->PHPSESSID])
            ->andFilterWhere(['like', 't.ip', $this->ip]);

        return $dataProvider;
    }
}
